#include <X11/Xlib.h>
#include <X11/X.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#include <fcntl.h>
#include <sys/mman.h> 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include "../mv1.h"
#include "../fglib.h"
#define NUM_COLS 64

XImage *xim;
Display *display;
Window window;
GC gc;
int xsize=768;
int ysize=576;
u_char *data;
XShmSegmentInfo shminfo;
int screen_num;
Screen *screen;
//u_char colors[256];
u_long colors[256];
MV1_Ctrl *bd;

void grabproc()
{
//  memcpy(data,bd->video_mem +65536,xsize*ysize); 
  lseek(bd->raw_fd,0,SEEK_SET);
  read(bd->raw_fd,data,xsize*ysize);
  XShmPutImage(display,window,gc,xim,0,0,50,50,xsize,ysize,False);
  XSync(display,False);
}
int
main (int argc,char  *argv[]) {
   int i,lut;
    XColor tofind[256];

    if( (display = XOpenDisplay(NULL))==NULL) {
	printf("DISPLAYOPENERROR \n");
	exit(1);
    }
    screen_num = DefaultScreen(display);
    screen = DefaultScreenOfDisplay(display);
    window = RootWindow(display,screen_num);
	
    /* Do we have shared memory ? */
    if (!XShmQueryExtension (display)) {
        fprintf(stderr,"SHM not supported.\n"); exit(-1);
    }
     gc=XCreateGC(display, window,0,NULL); 

     for (i=0; i< NUM_COLS; i++) {
	tofind[i].red = tofind[i].green = tofind[i].blue = (65536/NUM_COLS)*i;
     }
     if(FG_TryGlobalCmap(display,tofind,NUM_COLS,colors)<0) {
      		fprintf (stderr,"Not enough colors. Using random colors\n");
     } 
	
     bd=MV1_Open(0);
     lut = MV1_GetPrivateLut(bd);
     if(lut<0)perror("can't get private lut");
     printf("lut is %d\n",lut);
     {
        double i;
        double gamma = 1;
        for(i=0;i<256;i++){
		int k,j,l = (int)i;
                int  intens = (-gamma*i*i/65536+(gamma+1) * i/256)*256;
                k = colors[ (NUM_COLS * intens/256) % NUM_COLS];
		j = k+(k<<8)+(k<<16)+(k<<24);
		MV1_LutWriteValue(j,l+(l<<8)+(l<<16)+(l<<24),lut,bd);
        }
     }
	
     xim=XShmCreateImage(display,
                  DefaultVisualOfScreen(DefaultScreenOfDisplay(display)),
                  8,ZPixmap,NULL,&shminfo,xsize,ysize);
     shminfo.shmid=shmget(IPC_PRIVATE,xim->bytes_per_line*xim->height,
                   IPC_CREAT|0777);
	
     data=shminfo.shmaddr=xim->data=shmat(shminfo.shmid,0,0);
     shmctl(shminfo.shmid,IPC_RMID,NULL);
     shminfo.readOnly=False;
     XShmAttach(display,&shminfo);
     while(1){	
//	MV1_SetFilterCutoff(127,bd);	
	grabproc();
//	MV1_SetFilterCutoff(42,bd);
	
	grabproc();
     }
}
